; Kasino v1.0
; Kashan A. Shaikh
; 8/20/99
; http://www.angelfire.com/ri/kshaikh/

.nolist
	#include "sos.inc"
	#include "joeti83.inc"

#define TOTAL_NUM_CARDS		5
#define CARD_HEIGHT		24
#define CARD_X			9
#define CARD_Y			3
#define VALUE_ROW_UPPER		$10
#define VALUE_ROW_LOWER		$31
#define VALUE_COL		$0e

;-----------------------------------------------
#define menu_pos	sram	; menu position
#define card_value	sram+1	; (10 bytes) 1-13 (1st 5 = user's, 2nd 5 = dealer's)
#define card_suit	sram+11	; (10 bytes) 0=clubs, 1,diamonds, 2=hearts, 3=spades
#define card_num	sram+21	; (2 bytes) # of active cards (1st = user, 2nd = dealer)
#define card_flip_flag	sram+23 ; (5 bytes) 0=face card, 1=flipped
#define	bet_amount	sram+28 ; (11 bytes)
#define current_score	sram+39	; (11 bytes)
#define temp		sram+50	; (2 bytes) stores value and suit for checking
#define temp_stuff	sram+52 ; (2 bytes)
#define stand_flag	sram+54 ; (2 bytes) 0=no stand, 1=standing (1st=user, 2nd=comp)
#define ace_flag	sram+56 ; (1 byte)
#define temp_tot	sram+57 ; (2 bytes)
#define max_score	sram+59 ; (11 bytes) saves max score attained
#define flush_flag	sram+70 ; (1 byte)
#define straight_flag	sram+71 ; (1 byte)
#define royal_flag	sram+72 ; (1 byte)
#define same_cards	sram+73 ; (2 bytes) (2nd byte used if more than one pair of like cards)
;------------------------------------------------

.list

.org $9327

	xor	a			; SOS
	jr	z,start_of_program
	.dw	libraries-$9327
	.dw	description

;--------++ LIBRARIES ++--------
libraries:
	.db "ZINPT",0,0,0,lib1,vec0	; waitkey
	.db "ZINPT",0,0,0,lib2,vec1	; string input
	.db "ZGFXL",0,0,0,lib1,vec2	; large sprite
	.db "ZGFXL",0,0,0,lib2,vec3	; fastcopy
	.db "ZLIB",0,0,0,0,lib2,vec4	; random
	.db "ZLMATH",0,0,lib1,vec5	; numeric input
	.db "ZLMATH",0,0,lib2,vec6	; op1 to (de)
	.db "ZLMATH",0,0,lib3,vec7	; (de) to op1
	.db $FF
	#define	waitkey		vector0
	#define stringinput	vector1
	#define largesprite	vector2
	#define fastcopy	vector3
	#define random		vector4
	#define numericinput	vector5
	#define op1_to_de	vector6
	#define de_to_op1	vector7

;--------++ START ++--------
;--------++ TITLE SCREEN ++--------
start_of_program:
	ld	hl,100
	call	_setxxxxop2
	call	_op2toop1
	ld	de,current_score
	call	op1_to_de
	ld	de,max_score
	call	op1_to_de
	set	7,(iy+20)
	ld	a,1
	ld	(menu_pos),a
return_to_start:
	call	_clrscr
	call	_clrgbuf
	ld	de,current_score
	call	de_to_op1
	call	_op2set0
	call	_cpOp1Op2
	jp	z,broke_exit		; user is broke
	call	_op1set0
	ld	de,bet_amount
	call	op1_to_de
	call	reset_vars
	xor	a
	ld	l,27
	call	card_back_display
	ld	a,83
	ld	l,27
	call	card_back_display
	set	3,(iy+5)		; set inverse text
	ld	hl,$0000
	ld	(pencol),hl
	ld	b,96
space_loop:
	call	_vputblank
	djnz	space_loop
	ld	hl,$001f
	ld	(pencol),hl
	ld	hl,description
	call	_vputs
	res	3,(iy+5)		; reset inverse text
	ld	hl,$0900
	ld	(pencol),hl
	ld	hl,text_high		; Highroller:
	call	_vputs
	ld	hl,top_name
	call	_vputs
	ld	hl,$0f00
	ld	(pencol),hl
	ld	hl,text_total		; Earnings:
	call	_vputs
	ld	de,top_money
	call	de_to_op1
	call	display_score_small
	ld	hl,$1911
	ld	(pencol),hl
	ld	hl,text_blackjack	; Blackjack
	call	_vputs
	ld	hl,$2011
	ld	(pencol),hl
	ld	hl,text_poker		; Poker
	call	_vputs
	ld	hl,$2711
	ld	(pencol),hl
	ld	hl,text_slots		; Slots
	call	_vputs
	ld	hl,$2e11
	ld	(pencol),hl
	ld	hl,text_exit		; Exit
	call	_vputs
	ld	hl,$3a00
	ld	(pencol),hl
	ld	hl,text_current
	call	_vputs
	ld	de,current_score
	call	de_to_op1
	call	display_score_small

menu_before:
	call	highlight_on_off
menu:	
	call	waitkey
	cp	54			; [2ND]
	jp	z,menu_done
	cp	9			; [ENTER]
	jp	z,menu_done
	dec	a
	jr	z,menu_down
	dec	a
	dec	a
	dec	a
	jr	nz,menu
menu_up:
	call	highlight_on_off
	ld	hl,menu_pos
	dec	(hl)
	jr	nz,menu_before
menu_up_repeat:
	ld	(hl),4
	jr	menu_before
menu_down:
	call	highlight_on_off
	ld	a,4
	ld	hl,menu_pos
	sub	(hl)
	jr	z,menu_down_repeat
	inc	(hl)
	jr	menu_before
menu_down_repeat:
	ld	(hl),1
	jr	menu_before

;----
highlight_on_off:
	ld	a,(menu_pos)
	ld	l,a
	ld	h,12*7
	call	_htimesl
	ld	de,gbuf+(12*$19)+2-(12*7)
	add	hl,de
h_line_loop:
	ld	b,7
h_outer_loop:
	push	bc
	ld	b,8
h_inner_loop:
	ld	a,(hl)
	cpl
	ld	(hl),a
	inc	hl
	djnz	h_inner_loop
	ld	bc,12-8
	add	hl,bc
	pop	bc
	djnz	h_outer_loop
	jp	fastcopy

;--------++ DECIDE WHICH GAME ++--------
menu_done:
	ld	a,(menu_pos)
	dec	a
	jp	z,blackjack_begin
	dec	a
	jp	z,poker_begin
	dec	a
	jp	z,slots_begin
	jp	exit

;--------++ RESET VARIABLES ++--------
reset_vars:
	ld	hl,card_value
	ld	b,27
reset_vars_loop:
	ld	(hl),0
	inc	hl
	djnz	reset_vars_loop
	ret

;--------++ DISPLAY CARD BACK SPRITE ++--------
;input: a=x l=y
card_back_display:
	ld	ix,card_back
	jr	display_card_both

;--------++ DISPLAY FACE CARD SPRITE ++--------
;input: a=x l=y
card_face_display:
	ld	ix,card_general
display_card_both:
	ld	b,CARD_HEIGHT
	ld	c,2
	jp	largesprite
	
;--------++--------++ DISPLAY THE CARD ++--------++--------
;input: a=card #, de=location to begin, l=card_y, *set penrow before calling*
display_card:
	ld	b,a
	ld	c,a
	ld	(temp_stuff),a
	ld	a,l
	ld	(temp_stuff+1),a
	ld	a,VALUE_COL-16d
column_loop:
	add	a,16
	djnz	column_loop
	ld	(pencol),a
	ld	b,c
	dec	de
inc_val_loop:
	inc	de
	djnz	inc_val_loop	
	push	de
	ld	a,(de)
	call	value_display
	ld	a,(temp_stuff)
	ld	b,a
	ld	a,(temp_stuff+1)
	ld	l,a
	ld	a,CARD_X-16
face_x_loop:
	add	a,16
	djnz	face_x_loop
	ld	(temp_stuff),a
	call	card_face_display
	pop	de
	ld	b,10
inc_suit_loop:
	inc	de
	djnz	inc_suit_loop
	ld	a,(de)
	ld	h,a
	ld	a,(temp_stuff)
	add	a,3
	ld	d,a
	ld	a,(temp_stuff+1)
	add	a,3
	ld	l,a
	ld	a,h
	jp	suit_display


;--------++ DISPLAY SUIT SPRITE ++--------
;input: a=suit # d=x l=y
suit_display:
	ld	ix,club_icon
	ld	b,a
	or	a
	jr	z,sd_next
suit_display_loop:
	inc	ix
	djnz	suit_display_loop
sd_next:
	ld	b,6
	ld	c,1
	ld	a,d
	jp	largesprite

;--------++ DISPLAY CARD VALUE ++--------
;input: a=value (place penrow and pencol before calling)
value_display:
	ld	b,a
	dec	a
	jr	z,value_display_ace
	sub	9
	jr	z,value_display_ten
	dec	a
	jr	z,value_display_jack
	dec	a
	jr	z,value_display_queen
	dec	a
	jr	z,value_display_king
value_display_now:
	ld	a,b
	call	_setxxop1
	ld	a,1
	jp	_dispop1a
value_display_ten:
	ld	a,b
	call	_setxxop1
	ld	hl,pencol
	dec	(hl)
	dec	(hl)
	ld	a,2
	jp	_dispop1a	
value_display_ace:
	ld	hl,text_chars
	jr	value_display_chars
value_display_jack:
	ld	hl,text_chars+1
	jr	value_display_chars
value_display_queen:
	ld	hl,text_chars+2
	jr	value_display_chars
value_display_king:
	ld	hl,text_chars+3
value_display_chars:
	ld	a,(hl)
	jp	_vputmap

;--------++ ERASE CARD FROM GRAPH BUFFER ++--------
;input: b=card#
card_erase:
	ld	hl,gbuf+(12*CARD_Y)-1
erase_x_loop:
	inc	hl
	inc	hl
	djnz	erase_x_loop
	ld	b,24
	xor	a
card_erase_y_loop:
	ld	(hl),a
	inc	hl
	ld	(hl),a
	ld	de,11
	add	hl,de
	djnz	card_erase_y_loop
	ret

;--------++ DISPLAY TEXT VERTICALLY ++--------
;input: b=# chars, hl=pointer to 1 past the string location
vert_name_loop:
	dec	hl
	ld	a,(hl)
	call	_vputmap
	ld	a,(penrow)
	sub	5
	ld	(penrow),a
	ld	a,1
	ld	(pencol),a
	djnz	vert_name_loop
	ret

;--------++ DRAW A HORIZONTAL LINE ++--------
horizontal_line:
	ld	hl,gbuf+(12*30)
	ld	b,12
horiz_lineloop:
	ld	(hl),$FF
	inc	hl
	djnz	horiz_lineloop
	ret

;----====----****----====----****----====++ BLACKJACK ++====----****----====----****----====----
blackjack_begin:
	call	_clrscr
	call	_clrgbuf
	ld	hl,$0000
	ld	(stand_flag),hl	

	call	horizontal_line
vertical_line:
	ld	hl,gbuf
	ld	de,12
	ld	b,64
vert_lineloop:
	ld	a,$f8			; %11111000
	ld	c,(hl)
	or	c
	ld	(hl),a
	add	hl,de
	djnz	vert_lineloop
		
	set	3,(iy+5)			; set inverse text
	ld	hl,$1101
	ld	(pencol),hl
	ld	b,3
	ld	hl,text_you+3
	call	vert_name_loop			; Y o u
	ld	hl,$3901
	ld	(pencol),hl
	ld	b,6
	ld	hl,text_dealer+6
	call	vert_name_loop			; D e a l e r
	res	3,(iy+5)			; reset inverse text

blackjack_card1_USER:				; PLAYER'S HAND
	call	new_card
	ld	a,(temp)
	ld	(card_value),a
	ld	a,(temp+1)
	ld	(card_suit),a
	ld	a,VALUE_ROW_UPPER
	ld	(penrow),a
	sub	VALUE_ROW_UPPER-1		; ld a,1
	ld	(card_num),a
	ld	de,card_value
	ld	l,CARD_Y
	call	display_card			; a=card #, de=pointer to start, l=y
blackjack_card2_USER:	
	call	new_card
	ld	a,(temp)
	ld	(card_value+1),a
	ld	a,(temp+1)
	ld	(card_suit+1),a
	ld	a,VALUE_ROW_UPPER
	ld	(penrow),a
	sub	VALUE_ROW_UPPER-2		; ld a,2
	ld	(card_num),a
	ld	de,card_value
	ld	l,CARD_Y
	call	display_card

blackjack_card1_DEALER:				; DEALER's hand
	call	new_card
	ld	a,(temp)
	ld	(card_value+5),a
	ld	a,(temp+1)
	ld	(card_suit+5),a
	ld	a,1
	ld	(card_num+1),a
	ld	a,CARD_X
	ld	l,63-24-CARD_Y
	call	card_back_display
blackjack_card2_DEALER:	
	call	new_card
	ld	a,(temp)
	ld	(card_value+6),a
	ld	a,(temp+1)
	ld	(card_suit+6),a
	ld	a,VALUE_ROW_LOWER
	ld	(penrow),a
	sub	VALUE_ROW_LOWER-2		; ld a,2
	ld	(card_num+1),a
	ld	de,card_value+5
	ld	l,63-24-CARD_Y
	call	display_card

	
	call	bj_display_usertot_small
	ld	hl,$0003
	call	enter_bet			; enter the bet


;---------------------------
bj_hit_stand_loop:	
	call	blackjack_choice		; hit or stand
	jp	nz,user_no_hit			; z=0 if standing
	ld	de,card_num
	ld	hl,card_value
	call	hit_me
	sub	5
	jp	z,user_no_hit
	ld	a,VALUE_ROW_UPPER
	ld	(penrow),a
	ld	a,(card_num)
	ld	de,card_value
	ld	l,CARD_Y
	call	display_card
	call	bj_display_usertot_small
	call	fastcopy
	ld	a,(card_num)
	ld	de,card_value
	call	total_card_value
	sub	22
	jr	nc,bj_show
dealer_hit_stand:	
	ld	a,(card_num+1)
	ld	de,card_value+5
	call	total_card_value
	sub	18
	jp	nc,dealer_no_hit
	ld	de,card_num+1
	ld	hl,card_value+5
	call	hit_me
	sub	5
	jp	z,dealer_no_hit
	ld	a,VALUE_ROW_LOWER
	ld	(penrow),a
	ld	a,(card_num+1)
	ld	de,card_value+5
	ld	l,63-24-CARD_Y
	call	display_card
	call	fastcopy
	jp	stand_both

;-----------------------------------
bj_show:	
	call	show_hidden
	ld	a,(card_num+1)
	ld	de,card_value+5
	call	total_card_value		; dealer total
	ld	(temp_tot+1),a
	ld	hl,$3a57
	ld	(pencol),hl
	call	bj_display_anytot_small
	
	set	3,(iy+5)			; set inverse text
	ld	a,(card_num)
	ld	de,card_value
	call	total_card_value		; user total
	ld	(temp_tot),a
	sub	22
	jr	nc,user_busted
bj_back:	
	ld	a,(temp_tot+1)
	sub	22
	jr	nc,dealer_busted
	ld	a,(temp_tot+1)
	ld	b,a
	ld	a,(temp_tot)
	cp	b
	jr	z,bj_tie
	sub	b
	jr	nc,user_wins
dealer_wins:
	ld	a,(temp_tot+1)
	ld	hl,$0806
	call	disp_big_tot
	ld	hl,$0506
	ld	(currow),hl
	ld	hl,text_win
	call	_puts
	call	waitkey
	ld	hl,$0403
	call	subtract_bet
	jr	bj_finish	
user_wins:
	ld	a,(temp_tot)
	ld	hl,$0802
	call	disp_big_tot
	ld	hl,$0502
	ld	(currow),hl
	ld	hl,text_win
	call	_puts
	call	waitkey
	ld	a,1
	ld	hl,$0403
	call	add_winnings
	jr	bj_finish
bj_tie:
	ld	hl,$0503
	ld	(currow),hl
	ld	hl,text_tie
	call	_puts
bj_finish:
	res	3,(iy+5)			; reset inverse text
	call	waitkey
	jp	return_to_start			; BLACKJACK IS OVER
;------------------------------

;----------
user_busted:
	ld	hl,$0802
	add	a,22
	call	disp_big_tot
	ld	hl,$0502
	ld	(currow),hl
	ld	hl,text_busted
	call	_puts
	jr	dealer_wins
dealer_busted:
	ld	hl,$0806
	add	a,22
	call	disp_big_tot
	ld	hl,$0506
	ld	(currow),hl
	ld	hl,text_busted
	call	_puts
	jr	user_wins

;--------
show_hidden:
	ld	a,CARD_X
	ld	l,63-24-CARD_Y
	call	card_back_display		; erase dealer card
	ld	a,VALUE_ROW_LOWER
	ld	(penrow),a
	sub	VALUE_ROW_LOWER-1			; card #1
	ld	de,card_value+5
	ld	l,63-24-CARD_Y
	call	display_card			; display hidden dealer card
	jp	fastcopy

;--------
disp_big_tot:
	push	hl
	call	_setxxop1
	pop	hl
	jp	_dispExpr

bj_display_usertot_small:
	ld	hl,$0157
	ld	(pencol),hl
	ld	a,(card_num)
	ld	de,card_value
	call	total_card_value
bj_display_anytot_small:	
	call	_setxxop1
	ld	a,2
	call	_dispop1a
	jp	fastcopy

;--------
user_no_hit:
	ld	a,1
	ld	(stand_flag),a
	jr	stand_both
dealer_no_hit:
	ld	a,1
	ld	(stand_flag+1),a
stand_both:
	ld	hl,(stand_flag)
	ld	de,$0101
	sbc	hl,de
	jp	z,bj_show
	ld	a,(stand_flag)
	or	a
	jp	z,bj_hit_stand_loop
	jp	dealer_hit_stand

;---BLACKJACK-ROUTINE---User hit or stand?
; Output: z=1 if standing, z=0 if hitting
blackjack_choice:
	call	waitkey
	ld	hl,$0303
	ld	(currow),hl
	ld	hl,text_bjchoice
	call	_puts
	ld	hl,$0104
	ld	(currow),hl
	ld	hl,text_bjchoice+11
	call	_puts
bj_wait_again:
	call	waitkey
	sub	9			; [ENTER]
	jr	z,bj_done
	sub	54-9			; [2ND]
	jr	nz,bj_wait_again
	ret
bj_done:
	inc	a
	ret

;---BLACKJACK-ROUTINE---Add one to card number
; Input: de = location of card number (user or comp), hl=location of values
; Output: a=5 if max cards already
hit_me:
	ld	a,(de)
	cp	5
	ret	z
	inc	a
	ld	(de),a
	push	hl
	push	de
	call	new_card
	pop	de
	pop	hl
	ld	a,(de)
	dec	hl
	ld	b,a
after_hit_loop:
	inc	hl
	djnz	after_hit_loop
	ld	a,(temp)
	ld	(hl),a
	ld	b,10
after_hit_loop2:
	inc	hl
	djnz	after_hit_loop2
	ld	a,(temp+1)
	ld	(hl),a
	xor	a
	ret

;---BLACKJACK-ROUTINE--Total card value
;input: a=# cards, de=place to start adding (user or comp)
total_card_value:
	ld	(temp_stuff),a
	ld	b,a
	xor	a
	ld	(ace_flag),a
	ld	c,a
bj_total_loop:
	ld	a,(de)
	dec	a
	jr	z,ace_found
	sub	9
	jr	c,below_ten
	xor	a
below_ten:	
	add	a,10
below_ten_add:	
	add	a,c
	ld	c,a
	inc	de
	djnz	bj_total_loop

was_an_ace_found:
	ld	a,(ace_flag)
	or	a
	jr	z,no_ace
	ld	a,(temp_stuff)
	sub	2
	jr	nz,more_than_two
	ld	a,c
	add	a,10
	sub	21
	jr	z,twenty_one
more_than_two:
	ld	a,c
	add	a,9
	sub	22
	jr	nc,no_ace
	add	a,22
	ld	c,a
	jr	no_ace
twenty_one:
	ld	c,21
no_ace:
	ld	a,c
	ret
ace_found:
	ld	a,1
	ld	(ace_flag),a
	jr	below_ten_add
	

;----====----****----====----****----====++ POKER ++====----****----====----****----====----
p_b_showerase:	
	ld	b,5
	ld	c,CARD_X
poker_back_loop:
	push	bc
	ld	a,c
	ld	l,CARD_Y
	call	card_back_display		; show/erase 5 card backs
	pop	bc
	ld	a,c
	add	a,16
	ld	c,a
	djnz	poker_back_loop
	jp	fastcopy

poker_begin:					; BEGIN POKER
	call	_clrscr
	call	_clrgbuf
	call	horizontal_line
	call	p_b_showerase

	ld	hl,$0004
	call	enter_bet			; enter the bet	

	call	p_b_showerase

	ld	de,card_value
	ld	b,5
poker_card_loop:
	push	bc
	push	de
	call	new_card
	pop	de
	pop	bc
	ld	a,(temp)
	ld	(de),a
	ld	hl,10
	add	hl,de
	ld	a,(temp+1)
	ld	(hl),a
	ld	a,VALUE_ROW_UPPER
	ld	(penrow),a
	sub	VALUE_ROW_UPPER-6		; ld a,6
	sub	b
	ld	(card_num),a
	push	bc
	push	de
	ld	de,card_value
	ld	l,CARD_Y
	call	display_card			; a=card #, de=pointer to start, l=y
	pop	de
	pop	bc
	inc	de
	djnz	poker_card_loop
	call	fastcopy
	
poker_flip:					; FLIP CARDS
	ld	hl,$0005
	ld	(currow),hl
	ld	hl,text_flip
	call	_puts	
flip_loop:
	call	waitkey
	cp	54
	jr	z,flip_done
	cp	9
	jr	z,flip_done
	sub	49
	jr	c,flip_loop
	inc	a
	ld	de,card_flip_flag+5
	ld	b,a
	ld	c,6
	ld	a,CARD_X+64+16
flip_find_loop:
	dec	de
	sub	16
	dec	c
	djnz	flip_find_loop
	ld	b,c			; card #
	ld	c,a			; x value
	push	bc
	push	de
	call	card_erase
	pop	de
	pop	bc
	ld	a,(de)
	or	a
	jr	z,flip_not_yet
flip_already:
	xor	a
	ld	(de),a
	ld	a,VALUE_ROW_UPPER
	ld	(penrow),a
	ld	a,b
	ld	de,card_value
	ld	l,CARD_Y
	call	display_card
	call	fastcopy
	jp	flip_loop
flip_not_yet:
	ld	a,1
	ld	(de),a
	ld	a,c
	ld	l,CARD_Y
	call	card_back_display
	call	fastcopy
	jp	flip_loop

;------------
flip_done:
	ld	b,5
	ld	de,card_flip_flag
	ld	hl,card_value+5			; store new cards here temporarily
flip_new_loop:
	ld	a,(de)
	or	a
	jr	z,poker_keep
	push	bc
	push	de
	push	hl
	call	new_card
	pop	hl
	pop	de
	pop	bc
	push	de
	push	hl
	ld	a,(temp)
	ld	(hl),a
	ld	de,10
	add	hl,de
	ld	a,(temp+1)
	ld	(hl),a
	pop	hl
	pop	de
poker_keep:
	inc	de
	inc	hl
	djnz	flip_new_loop


	ld	b,5
	ld	c,1
	ld	hl,card_value+5
flip_draw_loop:
	ld	a,(hl)
	or	a
	jr	z,poker_no_draw	
	push	bc
	push	hl
	ld	de,5
	sbc	hl,de
	ld	(hl),a
	ld	de,15
	add	hl,de
	ld	a,(hl)				; store the new cards
	ld	de,5				; in the right spot
	sbc	hl,de
	ld	(hl),a
	ld	a,CARD_X-16
	ld	b,c
poker_x_loop:
	add	a,16
	djnz	poker_x_loop
	ld	l,CARD_Y
	call	card_back_display
	pop	hl
	pop	bc
	push	bc
	push	hl
	ld	a,VALUE_ROW_UPPER
	ld	(penrow),a
	ld	a,c
	ld	de,card_value
	ld	l,CARD_Y
	call	display_card
	pop	hl
	pop	bc
poker_no_draw:
	inc	c
	inc	hl
	djnz	flip_draw_loop

	call	fastcopy
	
;----- see what the player has (sort the cards first)
poker_calculate:
	ld	b,4
poker_value_sort:			; sort cards in increasing order
	push	bc
	ld	b,4
	ld	hl,card_value
sort_inner:
	push	bc
	push	hl
	ld	a,(hl)
	ld	c,a
	inc	hl
	ld	a,(hl)
	ld	d,a
	sub	c
	jr	nc,sort_keep
	ld	a,c
	ld	(hl),a
	dec	hl
	ld	a,d
	ld	(hl),a
	ld	de,10
	add	hl,de
	ld	a,(hl)
	ld	c,a
	inc	hl
	ld	a,(hl)
	ld	d,a
	ld	a,c
	ld	(hl),a
	dec	hl
	ld	a,d
	ld	(hl),a
sort_keep:
	pop	hl
	pop	bc
	inc	hl
	djnz	sort_inner
	pop	bc
	djnz	poker_value_sort

poker_find_out:				; find out what the player has

;---
	ld	b,5
	ld	hl,card_suit
	ld	a,(hl)
	ld	c,a
	ld	d,1
flush_loop:
	ld	a,(hl)
	sub	c
	jr	z,flush_yes
	ld	d,0
flush_yes:
	inc	hl
	djnz	flush_loop
	ld	a,d
	ld	(flush_flag),a		; FLUSH?

;---
	xor	a
	ld	(royal_flag),a
	ld	b,4
	ld	hl,card_value
	ld	d,1
straight_loop:
	ld	a,(hl)
	ld	c,a
	inc	hl
	ld	a,(hl)
	sub	c
	dec	a
	jr	z,straight_yes
	ld	a,c
	dec	a
	jr	nz,no_straight
	ld	a,(hl)
	sub	10
	jr	nz,no_straight
	inc	a
	ld	(royal_flag),a		; ROYAL STRAIGHT?
	ld	d,a	
	jr	straight_yes
no_straight:
	ld	d,0
	xor	a
	ld	(royal_flag),a
straight_yes:
	djnz	straight_loop
	ld	a,d
	ld	(straight_flag),a	; STRAIGHT?
	
;---
	ld	hl,$0000
	ld	(same_cards),hl
	ld	b,4
	ld	hl,card_value
	ld	d,1
	ld	e,1
same_card_loop:
	ld	a,(hl)
	ld	c,a
	inc	hl
	ld	a,(hl)
	sub	c
	jr	nz,not_same
	ld	a,d
	or	a
	jr	nz,same_next
	ld	a,e
	dec	a
	jr	z,same_next
	ld	a,e
	ld	(same_cards+1),a
	ld	e,1
same_next:
	inc	e
	ld	d,1
	jr	same_cont
not_same:
	ld	d,0
same_cont:
	djnz	same_card_loop
	ld	a,e
	ld	(same_cards),a		; store # of same cards

;--- WHAT DOES THE USER HAVE? 
poker_decide:
	ld	a,(royal_flag)
	or	a
	jr	z,pd_next1
	ld	a,(flush_flag)
	or	a
	jr	z,pd_next1
	ld	a,20
	ld	hl,$0406
	call	add_winnings
	ld	de,text_royalflush	; ROYAL FLUSH
	jp	poker_display
pd_next1:
	ld	a,(straight_flag)
	or	a
	jr	z,pd_next2
	ld	a,(flush_flag)
	or	a
	jr	z,pd_next2
	ld	a,15
	ld	hl,$0406
	call	add_winnings
	ld	de,text_straightflush	; STRAIGHT FLUSH
	jp	poker_display
pd_next2:
	ld	a,(same_cards)
	sub	4
	jr	nz,pd_next3
	ld	a,12
	ld	hl,$0406
	call	add_winnings
	ld	de,text_fourkind	; FOUR OF A KIND
	jp	poker_display
pd_next3:
	ld	a,(same_cards+1)
	or	a
	jr	z,pd_next4
	sub	2
	jr	z,full_check3
	ld	a,(same_cards)
	sub	2
	jr	nz,pd_next4
full_end:
	ld	a,10
	ld	hl,$0406
	call	add_winnings
	ld	de,text_fullhouse	; FULL HOUSE
	jr	poker_display
full_check3:
	ld	a,(same_cards)
	sub	3
	jr	z,full_end
pd_next4:
	ld	a,(flush_flag)
	or	a
	jr	z,pd_next5
	ld	a,8
	ld	hl,$0406
	call	add_winnings
	ld	de,text_flush		; FLUSH
	jr	poker_display
pd_next5:
	ld	a,(straight_flag)
	or	a
	jr	z,pd_next6
	ld	a,6
	ld	hl,$0406
	call	add_winnings
	ld	de,text_straight	; STRAIGHT
	jr	poker_display
pd_next6:
	ld	a,(same_cards)
	sub	3
	jr	nz,pd_next7
	ld	a,4
	ld	hl,$0406
	call	add_winnings
	ld	de,text_threekind	; THREE OF A KIND
	jr	poker_display
pd_next7:
	inc	a
	jr	nz,poker_nothing
	inc	a
	ld	hl,$0406
	call	add_winnings
	ld	de,text_twokind		; TWO PAIR
	jr	poker_display
poker_nothing:
	ld	hl,$0406
	call	subtract_bet
	ld	de,text_nothing		; nothing
poker_display:
	ld	hl,$0004
	ld	(currow),hl
	ex	de,hl
	call	_puts
poker_end:
	call	waitkey
	jp	return_to_start


;----====----****----====----****----====++ SLOTS ++====----****----====----****----====----
slots_begin:
	call	_clrscr
	call	_clrgbuf

	ld	a,89
	ld	l,30
	ld	b,5
	ld	c,1
	ld	ix,arrow_icon
	call	largesprite
	xor	a
	ld	l,30
	ld	b,5
	ld	c,1
	ld	ix,arrow_reverse
	call	largesprite

	call	slots_line_draw

	ld	hl,banana_icon
slots_before_draw:
	ld	(card_num),hl
	ld	a,16
	ld	(temp_stuff),a
	ld	b,3
slots_drawl:
	push	bc
	call	slots_cycle
	ld	a,(temp_stuff)
	add	a,24
	ld	(temp_stuff),a
	pop	bc
	djnz	slots_drawl
	call	fastcopy

	ld	hl,$0000
	call	enter_bet			; enter the bet

slots_random:
	ld	a,16-24
	ld	(same_cards+1),a
	ld	hl,banana_icon-(2*10)
	ld	(card_suit),hl
	ld	de,card_value
	ld	b,3
	ld	c,1
sl_go:
	push	bc
	push	de
	ld	a,b
	ld	(same_cards),a
	ld	a,(same_cards+1)
	add	a,24
	ld	(same_cards+1),a
	ld	b,22
	call	random
	add	a,50
	ld	b,a

sl_rot_loop:
	push	bc
	call	slots_clear_lbl
	call	slots_line_draw
	ld	hl,(card_suit)
	ld	de,2*10
	add	hl,de
	ld	de,seven_icon+(2*10)
	call	_cphlde
	jr	nz,sl_loop1_cont
	ld	hl,banana_icon
sl_loop1_cont:
	ld	(card_num),hl
	ld	(card_suit),hl
	ld	a,(same_cards+1)
	ld	(temp_stuff),a
	ld	a,(same_cards)
	ld	b,a
sl_loop1_loop1:
	push	bc
	call	slots_cycle
	ld	a,(temp_stuff)
	add	a,24
	ld	(temp_stuff),a
	pop	bc
	djnz	sl_loop1_loop1
	
	push	bc
	call	fastcopy
	pop	bc
	inc	c
	ld	a,c
	sub	8
	jr	c,sl_loop1_cont2
	ld	c,1
sl_loop1_cont2:
	ld	a,c
	pop	bc
	ld	c,a
	djnz	sl_rot_loop
	
	pop	de
	ld	a,c
	ld	(de),a
	inc	de
	ld	a,c
	pop	bc
	ld	c,a
	dec	b
	jp	nz,sl_go

	call	fastcopy

;from lowest to greatest (aids in finding # the same)
slots_sort:
	ld	b,2
slots_sort_outer:			; sort cards in increasing order
	push	bc
	ld	b,2
	ld	hl,card_value
slots_sort_inner:
	ld	a,(hl)
	ld	c,a
	inc	hl
	ld	a,(hl)
	ld	d,a
	sub	c
	jr	nc,slots_sort_keep
	ld	a,c
	ld	(hl),a
	dec	hl
	ld	a,d
	ld	(hl),a
	inc	hl
slots_sort_keep:
	djnz	slots_sort_inner
	pop	bc
	djnz	slots_sort_outer

	set	3,(iy+5)			; set inverse text
	ld	b,2
	ld	hl,card_value
	ld	d,1
	ld	e,0
slots_same_loop:				; find how many icons are the same
	ld	a,(hl)
	ld	c,a
	inc	hl
	ld	a,(hl)
	sub	c
	jr	nz,slots_same_cont
	inc	d
	ld	e,c
slots_same_cont:
	djnz	slots_same_loop
	ld	a,d
	sub	3
	jr	c,slots_two_same
slots_three_same:				; three are the same!
	ld	hl,$0400
	ld	a,e
	call	add_winnings
	jr	slots_display
slots_two_same:					; two are the same
	inc	a
	jr	nz,slots_nothing
	ld	hl,$0400
	ld	a,1
	call	add_winnings
	jr	slots_display
slots_nothing:
	ld	hl,$0400
	call	subtract_bet
slots_display:
	call	waitkey
	res	3,(iy+5)			; reset inverse text
	jp	return_to_start			; END OF SLOTS


;---
slots_line_draw:				; Draw some lines
	ld	hl,gbuf+(12*11)+1
	ld	b,4
slots_horiz_loop:
	push	bc
	ld	b,10
slots_line_loop:
	ld	(hl),$FF
	inc	hl
	djnz	slots_line_loop
	ld	de,(12*13)+2
	add	hl,de
	pop	bc
	djnz	slots_horiz_loop
	ld	hl,gbuf+(12*11)+1
	ld	b,2
slots_vert_loop:
	push	bc
	ld	b,14*3+1
	ld	de,12
	ld	c,$80
slots_line2_loop:
	ld	a,(hl)
	or	c
	ld	(hl),a
	add	hl,de
	djnz	slots_line2_loop
	ld	hl,gbuf+(12*11)+11
	pop	bc
	djnz	slots_vert_loop
	ret
;---

;---						; Clear area
slots_clear_lbl:	
	ld	hl,gbuf+(12*14)-1
	ld	a,(same_cards)
	ld	de,3
slots_clear_get:
	add	hl,de
	inc	a
	cp	4
	jr	nz,slots_clear_get
	ld	a,(same_cards)
	ld	b,a
slots_clear:
	push	hl
	push	bc
	ld	b,(14*3)
	xor	a
slots_clear_loop:
	ld	(hl),a
	inc	hl
	ld	(hl),a
	ld	de,11
	add	hl,de
	djnz	slots_clear_loop
	pop	bc
	pop	hl
	ld	de,3
	add	hl,de
	djnz	slots_clear
	ret
;---

;--------
slots_cycle:					; Draw the icons
	xor	a
	ld	(temp_stuff+1),a
	ld	hl,(card_num)
	ld	b,3
slots_cycle_loop:
	push	bc
	ld	(temp),hl
	ld	ix,(temp)
	ld	a,(temp_stuff+1)
	add	a,14
	ld	(temp_stuff+1),a
	ld	l,a
	ld	a,(temp_stuff)
	ld	b,10
	ld	c,2
	call	largesprite
	ld	hl,(temp)
	ld	de,2*10
	add	hl,de
	ld	de,seven_icon+(2*10)
	call	_cphlde
	jr	nz,slots_cycle_skip
	ld	hl,banana_icon
slots_cycle_skip:
	ld	(temp),hl
	pop	bc
	djnz	slots_cycle_loop
	ld	hl,(card_num)
	ld	de,2*10
	add	hl,de
	ld	de,seven_icon+(2*10)
	call	_cphlde
	jr	nz,slots_cycle_skip2
	ld	hl,banana_icon
slots_cycle_skip2
	ld	(card_num),hl
	ret
;--------	



;--------++--------++ CREATE A NEW CARD ++--------++--------
new_card:
	call	value_random
	ld	(temp),a
	call	suit_random
	ld	(temp+1),a
	call	check_duplicate
	jr	z,new_card
	ret

;--------++ RANDOM VALUE ++--------
value_random:
	ld	b,13
	call	random
	inc	a
	ret

;--------++ RANDOM SUIT ++--------
suit_random:
	ld	b,4
	call	random
	ld	h,6
	ld	l,a
	call	_htimesl
	ld	a,l
	ret

;--------++ CHECK FOR A DUPLICATE CARD ++--------
;input: temp=value temp+1=suit
;output: z=1 if found, z=0 if not
check_duplicate:
	ld	a,(temp)
	ld	c,a
	ld	hl,card_value
	ld	b,9
check_value_loop:
	ld	a,(hl)
	cp	c
	jr	z,dup_value_found
	inc	hl
	djnz	check_value_loop
check_done:
	ld	a,1
	ret

dup_value_found:
	ld	a,(temp+1)
	ld	c,a
	ld	hl,card_suit
	ld	b,9
check_suit_loop:
	ld	a,(hl)
	cp	c
	jr	z,duplicate_card_found
	inc	hl
	djnz	check_suit_loop
	jr	check_done
duplicate_card_found:
	xor	a
	ret	

;--------++ DISPLAY SMALL TEXT ++--------
;Input: op1 = number
display_score_small:
	ld	a,14
	jp	_dispop1a

;--------++ ENTER THE BET ++--------
;input: hl=location to place text
enter_bet:
re_enter:	
	set	3,(iy+5)			; set inverse text
	push	hl
	ld	(currow),hl
	ld	hl,text_money
	call	_puts
	res	3,(iy+5)			; reset inverse
	call	_puts				; spaces
	ld	de,current_score
	call	de_to_op1
	pop	hl
	push	hl
	ld	h,$08
	inc	l
	call	_dispExpr			; big text
	set	3,(iy+5)			; set inverse text
	pop	hl
	push	hl
	inc	l
	ld	(currow),hl
	ld	hl,text_bet
	call	_puts
	res	3,(iy+5)			; reset inverse
	call	_puts				; spaces
	pop	hl
	push	hl
	ld	h,$05
	inc	l
	ld	(currow),hl
	ld	a,9
	call	numericinput			; Enter Bet
	call	_ckOp1Pos
	jr	nz,enter_bet_reset
	ld	d,2
	call	_round				; round op1 to "d" decimal places
	call	_ckOp1Fp0
	jr	z,enter_bet_reset
	ld	de,bet_amount
	call	op1_to_de
	ld	de,current_score
	call	de_to_op1
	call	_op1toop2
	ld	de,bet_amount
	call	de_to_op1
	call	_cpOp1Op2
	jr	z,enter_bet_done
	jr	nc,enter_bet_reset
enter_bet_done:	
	pop	hl
	jp	fastcopy
enter_bet_reset:
	call	fastcopy
	pop	hl
	jr	re_enter

;--------++ SUBTRACT THE BET ++--------
;input: hl=currow,curcol position
subtract_bet:
	ld	(currow),hl
	call	fastcopy
	ld	de,bet_amount
	call	de_to_op1
	ld	hl,text_lost
	call	_puts
	ld	hl,(currow)
	ld	h,$05
	inc	l
	inc	l
	call	_dispExpr
	call	_op1toop2
	ld	de,current_score
	call	de_to_op1
	call	_cpOp1Op2
	jr	z,empty
	call	_fpsub
	ld	de,current_score
	jp	op1_to_de
empty:
	call	_op1set0
	ld	de,current_score
	jp	op1_to_de

;--------++ ADD TO EARNINGS ++--------
;input: a=multiple, hl=currow,curcol position
add_winnings:
	ld	(currow),hl
	call	_setxxop2
	call	fastcopy
	ld	de,bet_amount
	call	de_to_op1
	call	_fpmult
	ld	hl,text_earn
	call	_puts
	ld	hl,(currow)
	ld	h,$05
	inc	l
	inc	l
	call	_dispExpr
	call	_op1toop2
	ld	de,current_score
	call	de_to_op1
	call	_fpadd
	ld	de,current_score
	call	op1_to_de
	call	_op1toop2
	ld	de,max_score
	call	de_to_op1
	call	_cpOp1Op2
	ret	nc
	call	_op2toop1
	ld	de,max_score
	jp	op1_to_de

;--------++ EXIT THE GAME ++--------
broke_exit:
	ld	hl,$0203
	ld	(currow),hl
	ld	hl,text_broke
	call	_puts
	call	waitkey
exit:
	ld	de,max_score
	call	de_to_op1
	call	_Op1toOp2
	ld	de,top_money
	call	de_to_op1
	call	_cpOp1Op2
	jr	nc,no_high
new_high:
	call	_clrscr
	call	_clrgbuf
	set	3,(iy+5)			; set inverse text
	ld	hl,$0000
	ld	(currow),hl
	ld	hl,text_highroller
	call	_puts
	ld	hl,currow
	inc	(hl)
	ld	hl,text_money
	call	_puts
	res	3,(iy+5)
	call	_Op2toOp1
	ld	de,top_money
	call	op1_to_de
	ld	hl,$0803
	call	_dispExpr
	set	3,(iy+5)
	ld	hl,$0007
	ld	(currow),hl
	ld	hl,text_me
	res	2,(iy+13)			; do not scroll
	call	_puts
	set	2,(iy+13)
	ld	hl,$0005
	ld	(currow),hl
	ld	hl,text_enter
	call	_puts
	res	3,(iy+5)			; reset inverse
	ld	hl,curcol
	inc	(hl)
	ld	a,10
	ld	b,0
	ld	ix,top_name
	call	stringinput
no_high:
	res	7,(iy+20)
	ret

;--------++ TEXT ++--------
description:	.db "Kasino v1.0",0
text_me:	.db "Kashan A. Shaikh",0
text_blackjack:	.db "Blackjack",0
text_poker:	.db "Poker",0
text_slots:	.db "Slots",0
text_exit:	.db "Exit",0
text_high:	.db "Highroller: ",0
text_current:	.db "Your "
text_total:	.db "Earnings: ",0
text_chars:	.db "AJQK"
text_you:	.db "You",0
text_dealer:	.db "Dealer",0
text_money:	.db "Money:",0,"          ",0
text_bet:	.db "Bet:",0,"            ",0
text_bjchoice:	.db "2ND to hit",0
		.db "ENTER to stand",0
text_busted:	.db "Busted",0
text_win:	.db "Winner!",0
text_tie:	.db "Draw!",0
text_flip:	.db "Top  Keys  Flip "
		.db "2ND/ENTER deals",0
text_royalflush	.db "Royal Flush!!!",0
text_straightflush	.db "Straight Flush!!",0
text_fourkind	.db "Four of a Kind!",0
text_fullhouse	.db "Full House!",0
text_flush	.db "Flush!",0
text_straight	.db "Straight!",0
text_threekind	.db "Three of a Kind!",0
text_twokind	.db "Two Pair.",0
text_nothing	.db "Nothing there.",0
text_lost:	.db "You lost:",0
text_earn:	.db "You won:",0
text_highroller:.db "  Highroller!!  ",0
text_enter:	.db "Name:",0
text_broke:	.db "You're Broke  "
		.db "Please try again",0

;--------++ VARS ++--------
top_money:	.db	0,$82,$10,0,0,0,0,0,0,0,0
top_name:	.db	"Kashman   ",0

;--------++ SPRITES ++--------
card_back:
	.db	%11111111,%11111000
	.db	%10000000,%00001000
	.db	%10111111,%11101000
	.db	%10100001,%10101000
	.db	%10101111,%00101000
	.db	%10111101,%00101000
	.db	%10101011,%10101000
	.db	%10110001,%11101000
	.db	%10111001,%01101000
	.db	%10101100,%11101000
	.db	%10101101,%10101000
	.db	%10110111,%01101000
	.db	%10111001,%01101000
	.db	%10101011,%10101000
	.db	%10101101,%10101000
	.db	%10101110,%10101000
	.db	%10110110,%10101000
	.db	%10110100,%11101000
	.db	%10110010,%01101000
	.db	%10110011,%10101000
	.db	%10100110,%00101000
	.db	%10111111,%11101000
	.db	%10000000,%00001000
	.db	%11111111,%11111000
card_general:
	.db	%11111111,%11111000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%10000000,%00001000
	.db	%11111111,%11111000
club_icon:
	.db	%00010000
	.db	%00111000
	.db	%01010100
	.db	%11111110
	.db	%01010100
	.db	%00010000
diamond_icon:
	.db	%00010000
	.db	%00101000
	.db	%01000100
	.db	%01000100
	.db	%00101000
	.db	%00010000
heart_icon:
	.db	%01101100
	.db	%10010010
	.db	%10000010
	.db	%01000100
	.db	%00101000
	.db	%00010000
spade_icon:
	.db	%00010000
	.db	%00111000
	.db	%01111100
	.db	%01111100
	.db	%00010000
	.db	%00111000
arrow_icon:
	.db	%00010000
	.db	%01110000
	.db	%11111110
	.db	%01110000
	.db	%00010000
arrow_reverse:
	.db	%00001000
	.db	%00001110
	.db	%01111111
	.db	%00001110
	.db	%00001000
banana_icon:
	.db	%00000000,%00000011
	.db	%00000000,%00001111
	.db	%01100000,%00111111
	.db	%01111000,%11111110
	.db	%01111111,%11111110
	.db	%00111111,%11111000
	.db	%00011111,%11110000
	.db	%00000011,%11000000
	.db	%00000000,%00000000
	.db	%00000000,%00000000
lemon_icon:
	.db	%00000001,%11000000
	.db	%00000111,%10110000
	.db	%00001111,%11011000
	.db	%00001111,%11101000
	.db	%00011111,%11111100
	.db	%00011111,%11111100
	.db	%00001111,%11111000
	.db	%00001111,%11111000
	.db	%00000111,%11110000
	.db	%00000001,%11000000
coin_icon:
	.db	%00000001,%11000000
	.db	%00000110,%10110000
	.db	%00001101,%11011000
	.db	%00011010,%10101100
	.db	%00010001,%10000100
	.db	%00010000,%11000100
	.db	%00011010,%10101100
	.db	%00001101,%11011000
	.db	%00000110,%10110000
	.db	%00000001,%11000000
bar_icon:
	.db	%00000000,%00000000
	.db	%01111111,%11111111
	.db	%01001111,%01110011
	.db	%01010110,%10110101
	.db	%01001110,%10110011
	.db	%01001110,%00110111
	.db	%01010101,%11010011
	.db	%01001101,%11010101
	.db	%01111111,%11111111
	.db	%00000000,%00000000
bell_icon:
	.db	%00000000,%10000000
	.db	%00000001,%11000000
	.db	%00000011,%10100000
	.db	%00000111,%11010000
	.db	%00000111,%11010000
	.db	%00001111,%11101000
	.db	%00011111,%11111100
	.db	%00011111,%11111100
	.db	%00000000,%10000000
	.db	%00000000,%00000000
cherry_icon:
	.db	%00000001,%00000000
	.db	%00000000,%10000000
	.db	%00000000,%10000000
	.db	%00000011,%11100000
	.db	%00000111,%11010000
	.db	%00001111,%11101000
	.db	%00001111,%11101000
	.db	%00001111,%11111000
	.db	%00000111,%11110000
	.db	%00000001,%11000000
seven_icon:
	.db	%00000000,%00000000
	.db	%00001111,%11111000
	.db	%00001111,%11111000
	.db	%00000000,%01111000
	.db	%00000000,%11110000
	.db	%00000001,%11100000
	.db	%00000011,%11000000
	.db	%00000111,%10000000
	.db	%00001111,%00000000
	.db	%00000000,%00000000

.end
END